#pragma once

#include <crypta/lib/native/log/log.h>

#include <mapreduce/yt/interface/client.h>

namespace NCrypta::NOfflineCm {
    class TUpdateStateJob {
    public:
        struct TConfig {
            TString YtProxy;
            TString YtPool;
            NYT::TYPath SourceDir;
            NYT::TYPath DestinationTable;
            bool ShouldDropInput = false;
            size_t TablePackSize = 0;
            ui64 Ttl = 0;
        };

        TUpdateStateJob(const TConfig& config, NLog::TLogPtr log);

        int Do();

    private:
        const TConfig Config;
        NLog::TLogPtr Log;
    };
}
