#include "identify_request_parser.h"

#include <crypta/lib/native/http/request_parser/request_parser.h>

#include <library/cpp/http/misc/parsed_request.h>
#include <util/generic/hash_set.h>
#include <util/string/cast.h>
#include <util/string/split.h>

using namespace NCrypta::NCm;
using namespace NCrypta::NCm::NApi;
using namespace NCrypta::NHttp;

TIdentifyRequest NIdentifyRequestParser::Parse(const TString& query) {
    TParsedHttpLocation httpLocation(query);

    Y_ENSURE(httpLocation.Path == "/identify", "Not an /identify request: " << httpLocation.Path);

    return Parse(TCgiParameters(httpLocation.Cgi));
}

TIdentifyRequest NIdentifyRequestParser::Parse(const TCgiParameters& cgi) {
    TIdentifyRequest request;

    NRequestParser::Parse(request, cgi);
    request.Id = TId(cgi.Get("type"), cgi.Get("value"));

    return request;
}
