#pragma once

#include <crypta/cm/services/mutator/lib/handler_factory.h>
#include <crypta/cm/services/mutator/lib/handler_queue.h>
#include <crypta/lib/native/pqlib/cookie_queue.h>

#include <util/generic/vector.h>

namespace NCrypta::NCm::NMutator {
    class TParser {
    public:
        TParser(THandlerFactory& handlerFactory, NPQ::TCookieQueue& cookiesToCommit, TVector<THandlerQueue>& handlerQueues, TStats& stats);

        void Parse(NPQ::TConsumer::TReadResult&& readResult);

    private:
        THandlerFactory& HandlerFactory;
        NPQ::TCookieQueue& CookiesToCommit;
        TVector<THandlerQueue>& HandlerQueues;

        NLog::TLogPtr Log;
        TStats& Stats;
    };
}
