#pragma once

#include <crypta/lib/native/log/log.h>

#include <mapreduce/yt/util/temp_table.h>

namespace NCrypta::NDmp::NAdobe {
    class TParseRawBindingsJob {
    public:
        class TConfig {
        public:
            TString YtPool;
            TString YtProxy;

            NYT::TYPath InputDir;
            NYT::TYPath OutputDir;
            NYT::TYPath ErrorsDir;

            time_t ErrorsTtl;
            bool ShouldDropInput;
        };

        explicit TParseRawBindingsJob(const TConfig& config, NLog::TLogPtr log);

        int Do();

    private:
        const TConfig Config;
        NLog::TLogPtr Log;
    };
}
