Приложения
=====================

Этот тип правила позволяет найти тех, у кого установлены приложения, идентификаторы которых перечислены в правиле.

Из-за особенностей сбора списка установленных мобильных приложений пользователя, этот тип условий хорошо работает для пользователей Android и **плохо работает для пользователей iOS**.

Параметр *Минимальная пользовательская активность* для этого типа условий не учитывается.

## Android
Чтобы определить идентификатор приложения для Android, нужно найти его в [Google Play](https://play.google.com/store?hl=ru) и скопировать параметр **id** из ссылки.

Например, у приложения Яндекс.Карты ссылка вот такая: [https://play.google.com/store/apps/details?id=ru.yandex.yandexmaps&hl=ru](https://play.google.com/store/apps/details?id=ru.yandex.yandexmaps&hl=ru). Идентификатор приложения: **ru.yandex.yandexmaps**


## iOS
Для iOS собирается лишь малая часть установленных приложений. Чтобы определить идентификатор приложения для iOS, нужно:
1. Найти его в [App Store](https://www.apple.com/ru/search) и скопировать цифры из ссылки.
2. Подставить цифры вместо XXXXXXXXX в ссылку https://itunes.apple.com/lookup?id=XXXXXXXXX.
3. Скачается файл, в котором нужно найти ``bundleId``. Значение этого поля и есть идентификатор приложения.

Например, у приложения Яндекс.Карты ссылка вот такая: https://apps.apple.com/ru/app/яндекс-карты-и-транспорт/id313877526.
1. Копируем цифры **313877526**.
2. Вставляем в ссылку https://itunes.apple.com/lookup?id=313877526.
3. Находим в загруженном файле

       "bundleId":"ru.yandex.traffic"
   **ru.yandex.traffic** - идентификатор приложения.


<img src="https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-14%20at%204.44.45%20PM.png" alt="drawing" style="width:500px;"/>

