Создание сегмента в Лаборатории
=====================

Конструктор сегментов позволяет самостоятельно создавать сегменты — наборы пользователей, получаемых из разных источников данных по простым правилам.

После создания сегмента он будет готов к использованию (в нем появятся пользователи) через 1-2 дня.

{% note warning %}

Прежде, чем создавать сегмент, ознакомьтесь с [огранчиениями на создание и использование сегментов](https://a.yandex-team.ru/arc_vcs/crypta/docs/lab/constructor/restrictions.md).

{% endnote %}

## Как создать сегмент:

1. Открываем окно создания сегмента
    ![create-segment-screenshot](https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-14%20at%2010.04.58%20AM.png)

2. Создаем сегмент:
    * Придумываем название сегмента

    * Добавляем описание аудитории, которую планируем в него добавить

    * Указываем название одной или более задач в Трекере, в которых обсуждалась создание сегмента и планы по его использованию (например, тикет, в котором планируется РК с использованием этого сегмента). Тикет может находиться в любой очереди. Можно указать несколько задач

      ![add-ticket-gif](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif.gif)

    * Добавляем ответственных и наблюдателей, если нужно. Ответственный – тот, кто отвечает за сегмент (может выдавать доступ к нему в Яндекс.Аудиториях и т.п.). Наблюдатель – человек, заинтересованный в создании сегмента

      ![add-ticket-gif](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%281%29.gif)
    * Нажимаем *Создать*.

      ![create-segment-dialog-schreenshot](https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-14%20at%2010.15.45%20AM.png)

3. Добавляем экспорт для сегмента

    ![add-export-screenshot](https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-14%20at%2010.17.24%20AM.png)

    Если сегмент будет использоваться в Директе, Дисплее или Adfox, выберите экспорт в Я.Аудитории. Для Бананы предпочтительнее экспорт в 549 киворд (Crypta).

    ![add-export-dialog-gif](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%282%29.gif)

4. Добавляем правило

   Настраиваем условие по количеству дней активности пользователя в рамках заданного правила. По умолчанию выставляется 2 из 35 дней.
   Это значит, что в сегмент попадут пользователи, проявлявшие описанную в правиле активность хотя бы ``2`` дня за последние ``35`` дней.  Если указать, например, 15/30, найдутся пользователи, которые хотя бы половину из 30 дней делали то, что указано в правиле: ходили на сайты/делали поисковые зпросы и т.п. То есть чем меньше первое число и больше второе, тем больше пользователей попадут в сегмент. Нельзя указать период более 35 дней

   ![select-activity-days-gif](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%283%29.gif)

5. Добавляем условия, по которым будет строиться сегмент. Их может быть несколько, но далее рассматриваем процесс добавления одного. Подробно типы условий описаны в соседнем разделе **Типы условий**

    ![select-condition-screenshot](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%284%29.gif)

6. Настраиваем условие

    ![set-condition-screenshot](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%285%29.gif)

7. Сохраняем условие

    ![save-conditions-screenshot](https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-14%20at%201.01.51%20PM.png)
    
    Если при написании условия вы ошиблись, после сохранения вы увидите сообщение об ошибке.

    ![constructor-condition-error](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%287%29.gif)

    Чтобы условие ушло в расчет, достаточно исправить ошибки и сохранить правило

    ![adjust-broken-condition](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%286%29.gif)

8. Некоторые типы условий требуют ручной проверки. Если после сохранения внизу появилась кнопка *Отправить на проверку*, нужно ее нажать

    ![send-to-review](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%288%29.gif)

    По нажатию этой кнопки создается тикет на проверку сегмента. После того, как правило будет проверено дежурным из Крипты, оно начнет считаться

    ![go-to-ticcket](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-video-to-gif%20%289%29.gif)
 

9. После сохранения хотя бы одного из условий, правило будет ежедневно пересчитываться, пользователи в сегменте будут обновляться каждый день. Первые пользователи в сегменте появятся через 1-2 дня после подтверждения условия (или сохранения правила, если подтверждение не нужно).

    Когда сегмент будет готов, его статус изменится на *active* и появится охват

    <img src="https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-14%20at%201.40.27%20PM.png" alt="drawing" style="width:400px;"/>
