Сегменты Лаборатории
==

[https://lab.crypta.yandex-team.ru/segments](https://lab.crypta.yandex-team.ru/segments)

## Группы сегментов
Все сегменты делятся на верхнем уровне на группы:
### Демография
  Пол, возраст, доход пользователей.
### Демография +
  Дополнительные социально-демографические характеристики пользователя. Например, семейное положение, наличие детей, профессия.
### Поведение
Общие характеристики, большая часть из которых доступна в медийных кампаниях в Директе.

### Интересы 2.0
  Интересы формируются на основе категорий поисковых запросов пользователей, заголовков посещаемых сайтов и т.п. ([полный список используемых факторов](https://docs.yandex-team.ru/crypta/lab/constructor/conditions/catalogia)). Выделяются краткосрочные и долгосрочные интересы пользователей.

  * **Краткосрочные** интересы показывают, к каким категориям Каталогии пользователь проявлял интерес от пары секунд до трех дней назад. Строятся прямо в ББ на основе [предоставляемой Криптой таблицы](https://yt.yandex-team.ru/hahn/navigation?path=//home/crypta/production/profiles/export/catalogia_to_interests) соответсвия категорий Каталогии краткосрочным интересам.
  * **Долгосрочные** — к каким тематикам пользователь проявлял интерес многократно и в течение продолжительного периода за последний месяц. Долгосрочный интерес будет у тех пользователей, у которых был соотвествующий краткосрочный интерес хотя бы 2 раза за последние 35 дней, причем между этими событиями прошло не меньше 14 дней.

  Таким образом, краткосрочные интересы отражают сиюминутную потребность человека, а долгосрочные — устойчивый интерес. При этом у пользователя может быть краткосрочный интерес к некоторой тематике и не быть к ней долгосрочного интереса, и наоборот.

### Посещения организаций

   [https://doc.yandex-team.ru/orgvisits](https://doc.yandex-team.ru/orgvisits/)

  В сегментах учитываются посещения за последние 35 дней.


### Посещения организаций (глубинные)

   [https://wiki.yandex-team.ru/geotargeting/orgvisits/deepuses](https://wiki.yandex-team.ru/geotargeting/orgvisits/deepuses/)

  В сегментах учитываются посещения за последние 35 дней.

### Оффлайн покупки

  Сегменты оффлайн покупок товаров соответствующих категорий по данным Едадила.

### Обучаемые сегменты

  [https://wiki.yandex-team.ru/crypta/profilesexport/duty/trainablesegments](https://wiki.yandex-team.ru/crypta/profilesexport/duty/trainablesegments/)
### Категории общие

  Общие и проверенные временем сегменты. Покрывают основные области и группы пользователей. Доступны всем.
  Такие сегменты можно и нужно использовать для общей аналитики и описания аудитории.
### Категории внешние

  Индивидуальные коммерческие сегменты. Делаются по заказу внешних рекламодателей. Для построения этих сегментов могут использоваться какие-то данные клиента или дополнительные фильтры и прочие смещения.
  Такие сегменты не стоит использовать для общей аналитики и описания аудитории без четкого понимания содержания сегмента.

### Категории внутренние

  Индивидуальные маркетинговые сегменты. Создаются под конкретные задачи сервисов Яндекса. Могут меняться по содержанию и по охвату аудитории по требованию заказчика.
  Такие сегменты не стоит использовать для общей аналитики и описания аудитории без четкого понимания содержания сегмента.

### Жанры кино
Сегменты любителей определенных жанров кино, построенные на основании посещения карточек фильмов соотвеествующих жанров на Кинопоисске.

### Музыкальные жанры
Сегменты любителей определенных жанров музыки, построенные на основании прослушивания соответствующих жанров на Яндекс.Музыке.

### Прочее

  Отключенные сегменты или сегменты, которые по какой-то причине не попали в группы, перечисленные выше. В штатной ситуации такого быть не должно, поэтому лучше обходить такие сегменты стороной :)
- **Интересы**

    Интересы пользователя, которые определяются по посещению сайтов соответствующих категорий. Используются категории сайтов из Яндекс.Каталога (см. https://yandex.ru/yaca/).
 <span style="color: red">NB</span> Будут отключены летом после закрытия Яндекс.Дисплея. Используйте Интересы 2.0

### Сегменты пользователей
Сегменты, построенные внешними по отношению к Крипте людьми с помощью [конструктора сегментов](constructor/how-to-create-segment.md).

## Карточка сегмента
Карточка сегмента содержит основную информацию по сегменту.
Карточка открывается в правой части экрана на вкладке "Сегменты" после выбора сегмента.

<img src="https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-17%20at%202.33.20%20PM.png" alt="drawing" width="500"/>

### Общая информация по сегменту

#### ID
Идентификатор сегмента в Лаборатории.

#### Область применения

* **EXTERNAL** - общий сегмент. См. выше "Категории общие"
* **EXTERNAL_PRIVATE** - внешний сегмент. См. выше "Категории внешние"
* **INTERNAL** - внутренний сегмент. См. выше "Категории внутренние"

#### ST
Тикеты в Трекере на создание или изменение сегмента.

#### Ответственные

  Люди, которые отвечали за создание сегмента и к которым можно обратиться с вопросами по нему.
  Эти люди могут предоставлять досступ к сегменту в Аудиториях (если сегмент там доступен).

#### Наблюдатели
  Люди, которые используют или интересуются сегментом, хотят узнавать об изменениях, затрагивающих этот сегмент. Можно самостоятельно добавить себя, коллег или рассылку в Лаборатории.

### Экспорты сегмента
У каждого сегмента может быть несколько экспортов. Экспорты бывают нескольких типов:
* ``DEFAULT`` <span style="color: red">deprecated, будут заменены на ``HEURISTIC``, ``PROBABILISTIC``</span>
* ``MIRROR`` <span style="color: red">deprecated, будут заменены на ``HEURISTIC``, ``PROBABILISTIC``
* ``AUDIENCE`` <span style="color: red">deprecated, будут заменены на ``HEURISTIC``, ``PROBABILISTIC``</span>
* ``HEURISTIC`` - эвристический экспорт
* ``PROBABILISTIC`` - вероятностный экспорт
* ``INTEREST`` - экспорт Интересов 1.0, <span style="color: red">уже не поддерживаются!</span>
* ``LONGTERM`` - экспорт долгосрочных интересов (для Интересов 2.0).
* ``SHORTTERM`` - экспорт краткосрочных интересов (для Интересов 2.0).

Информация по каждому из экспортов включает:
- **ID**
  Идентификатор экспорта сегмента (в правом верхнем углу)
- **Статус**
  Состояние экспорта:
  * ``CREATED`` - недавно создан и еще не активен. Когда в Лабораторию придет информация о том, что сегмент появился в профилях пользователей, сегмент перейдет в состояние ``ACTIVE``.
  * ``ACTIVE`` - активен, можно использовать.
  * ``DEPRECATED`` - активен, но будет отключен в ближайшем будущем. Необходимо перестать его использовать.
  * ``DISABLED`` - выключен, может быть включен по запросу.
  * ``DELETED`` - удален и не может быть восстановлен в прежнем виде.

- **Поле в YT**
  Название колонки, в которой надо искать этот экспорт сегмента в таблицах профилей на Yt.Hahn.

  Таблицы:

  * за 1 день [//statbox/crypta-yandexuid-profiles-log](https://yt.yandex-team.ru/hahn/#page=navigation&path=//statbox/crypta-yandexuid-profiles-log)

  * за 14 дней [//home/crypta/production/profiles/export/profiles_for_14days](https://yt.yandex-team.ru/hahn/#page=navigation&path=//home/crypta/production/profiles/export/profiles_for_14days)

- **Keyword ID**
  Номер киворда в [BigB](https://wiki.yandex-team.ru/bigb/).
  [Подробности](https://wiki.yandex-team.ru/Crypta/ProfilesExport/BB/) про экспорт сегментов в BigB.
- **Segment ID**
  Номер сегмента в [BigB](https://wiki.yandex-team.ru/bigb/).
  Для экспортов, Keyword ID которых равен 557, соответствует номеру сегмента в Яндекс.Аудиториях.
  Подробности про экспорт сегментов в BigB [на вики](https://wiki.yandex-team.ru/Crypta/ProfilesExport/BB/).
- **Coverage**

  ``/ 1 DAY`` - Количество пользователей в сегменте в профилях за 1 день.
  Рассчитывается по логам профилей пользователей в [//statbox/crypta-yandexuid-profiles-log](https://yt.yandex-team.ru/hahn/#page=navigation&path=//statbox/crypta-yandexuid-profiles-log). Подробности про лог [на вики](https://wiki.yandex-team.ru/Crypta/ProfilesExport/YT/).

  ``/ 14 DAYS``
  Количество пользователей в сегменте в профилях за 14 дней.
  Рассчитывается по [таблице](https://yt.yandex-team.ru/hahn/#page=navigation&path=//home/crypta/production/profiles/export/profiles_for_14days) с профилями пользователей, которые были активны за 14 дней. Подробности про таблицу [на вики](https://wiki.yandex-team.ru/Crypta/ProfilesExport/YT/).
- **Статистика**
  Описание сегмента, включая распределение по полу, возрасту, доходу, городам, афинитивные слова, сайты и сегменты пользователей.

  <img src="https://jing.yandex-team.ru/files/terekhinam/stats.png" alt="drawing" width="500"/>
![](https://jing.yandex-team.ru/files/terekhinam/ezgif.com-gif-maker.gif
 )

 - **Правило**
 Условия, по которым пользователи попадают в сегмент. Подробнее про правила можно почитать в [разделе про констурктор сегментов](https://docs.yandex-team.ru/crypta/lab/constructor/how-to-create-segment).

    <img src="https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-17%20at%204.16.45%20PM.png" alt="drawing" width="500"/>

- **Выражение**
    Логическое выражение над экспортами сегментов. Пользователи, которые соответствуют логическому выражению, попадают в сегмент. Выражения имеют приоритет над Правилами.

    <img src="https://jing.yandex-team.ru/files/terekhinam/expression.png" alt="drawing" width="500"/>
- **Охват**
Исторические данные по охвату сегмента

    <img src="https://jing.yandex-team.ru/files/terekhinam/coverage.png" alt="drawing" width="500"/>
- **Директ**
Исторические данные по количеству денег, которые принесли открутки на этом сегменте. Есть только у сегментов, доступных всем в Директе.

    <img src="https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-17%20at%205.05.56%20PM.png" alt="drawing" width="500"/>

- **Свойства Аудиторий**
Есть только у сегментов, доступных в [Яндекс.Аудиториях](audience.yandex.ru). Свойства Аудиторий доступны только Автору и Отвесственным.

    <img src="https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-18%20at%2011.26.19%20AM.png" alt="drawing" width="500"/>

    Здесь можно отредактировать название сегмента в Яндекс.Аудиторих и настроить дотсупы.     [Подробнее про настроки доступа](https://docs.yandex-team.ru/crypta/lab/constructor#vydacha-dostupov-v-auditoriyah).

    <img src="    https://jing.yandex-team.ru/files/terekhinam/Screen%20Shot%202021-05-18%20at%2011.29.15%20AM.png" alt="drawing" width="600"/>





