package ru.yandex.crypta.graph.api.service.settings.model;

public class InfoParams {

    public static final InfoParams DEFAULT = new InfoParams(false, false, false, false);

    public boolean includeIdsInfo;
    public boolean includeComponentInfo;
    public boolean includeMergeInfo;
    public boolean includeEdgesBetween;

    public InfoParams(boolean includeIdsInfo, boolean includeComponentInfo,
                      boolean includeMergeInfo, boolean includeEdgesBetween) {
        this.includeIdsInfo = includeIdsInfo;
        this.includeComponentInfo = includeComponentInfo;
        this.includeMergeInfo = includeMergeInfo;
        this.includeEdgesBetween = includeEdgesBetween;
    }

    public InfoParams forNeighbourComponent() {
        return new InfoParams(
                includeIdsInfo,
                includeComponentInfo,
                false,
                false
        );
    }

    public InfoParams withNeighbours() {
        return new InfoParams(
                includeIdsInfo,
                includeComponentInfo,
                true,
                true
        );
    }


}
