BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(1200)

TEST_SRCS(metrica_test.py)

PEERDIR(
    contrib/python/mock
    crypta/graph/data_import/app_metrica_day/lib
    crypta/lib/python/yql_runner/tests
    devtools/swag/lib
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
    library/cpp/getopt
    crypta/lib/python/bt/tasks
    crypta/lib/python/getoptpb
)

RESOURCE(
    fixtures/metrica.spec.json                /fixtures/metrica.spec.json
    fixtures/metrica.json                     /fixtures/metrica.json
    fixtures/metrica_private.json             /fixtures/metrica_private.json
    fixtures/yabro.json                       /fixtures/yabro.json
    fixtures/cross_mobmet.spec.json           /fixtures/cross_mobmet.spec.json
    fixtures/cross_mobmet.json                /fixtures/cross_mobmet.json
    fixtures/metrika_params_owners.spec.json  /fixtures/metrika_params_owners.spec.json
    fixtures/metrika_params_owners.json       /fixtures/metrika_params_owners.json
)

DATA(
    # sandbox resource GEODATA5BIN_STABLE
    # sbr://491696398  # geodata5.bin
    sbr://669391278  # geodata6.bin; 2018-09-09
)

SIZE(LARGE)

TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

REQUIREMENTS(ram:9)

END()
