BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(1200)

TEST_SRCS(metrica_test.py)

PEERDIR(
    contrib/python/mock
    crypta/graph/data_import/app_metrica_month/lib
    crypta/lib/python/yql_runner/tests
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/dev_info_yt.json           /fixtures/dev_info_yt.json
    fixtures/dev_info_yt.spec.json      /fixtures/dev_info_yt.spec.json
    fixtures/dev_info_table.json        /fixtures/dev_info_table.json
    fixtures/dev_info_table.spec.json   /fixtures/dev_info_table.spec.json
    fixtures/uuid_info_yt.json          /fixtures/uuid_info_yt.json
    fixtures/uuid_info_yt.spec.json     /fixtures/uuid_info_yt.spec.json

    fixtures/am_log_table.json          /fixtures/am_log_table.json
    fixtures/am_log_table.spec.json     /fixtures/am_log_table.spec.json

    fixtures/fuzzy2_metrica.json        /fixtures/fuzzy2_metrica.json
    fixtures/fuzzy2_metrica.spec.json   /fixtures/fuzzy2_metrica.spec.json

    fixtures/postback_extra_data.json   /fixtures/postback_extra_data.json
    fixtures/postback_extra_data.spec.json   /fixtures/postback_extra_data.spec.json

    fixtures/rtb_extra_data.json        /fixtures/rtb_extra_data.json
    fixtures/rtb_extra_data.spec.json   /fixtures/rtb_extra_data.spec.json
)

DATA(
    # sandbox resource GEODATA5BIN_STABLE
    # sbr://491696398  # geodata5.bin
    sbr://669391278  # geodata6.bin; 2018-09-09
)

SIZE(LARGE)
TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)
INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

END()
