BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(2400)

TEST_SRCS(fp_test.py)

PEERDIR(
    crypta/graph/data_import/fp_parser/lib
    crypta/lib/python/yql_runner/tests
    yql/library/embedded/python
    yql/library/python
    ydb/library/yql/providers/common/proto
    yql/library/test_framework
    mapreduce/yt/python/lite
    devtools/swag/lib
    library/cpp/resource
    library/python/resource
    contrib/python/mock
)

RESOURCE(
    fixtures/bswatch_log.json           /fixtures/bswatch_log.json
    fixtures/passport_log.json          /fixtures/passport_log.json
    fixtures/barnavig_log.json          /fixtures/barnavig_log.json
    fixtures/reqans_log.json            /fixtures/reqans_log.json
    fixtures/reqans_log.spec.json       /fixtures/reqans_log.attrs.json
)

DATA(
    # sandbox resource GEODATA5BIN_STABLE
    # sbr://491696398  # geodata5.bin
    sbr://669391278  # geodata6.bin; 2018-09-09
)

SIZE(LARGE)

TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

END()
