BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(1200)

TEST_SRCS(test.py)

PEERDIR(
    contrib/python/mock
    crypta/graph/data_import/soup/lib
    crypta/lib/python/yql_runner/tests
    devtools/swag/lib
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
    library/cpp/getopt
    crypta/lib/python/bt/tasks
    crypta/lib/python/getoptpb
)

RESOURCE(
    fixtures/attr_processed.json    /fixtures/attr_processed.json
    fixtures/soup_mm.json           /fixtures/soup_mm.json
    fixtures/soup_wl.json           /fixtures/soup_wl.json
    fixtures/table_1.json           /fixtures/table_1.json
    fixtures/table_2.json           /fixtures/table_2.json
    fixtures/table_3.json           /fixtures/table_3.json
    fixtures/ids_yuid.json          /fixtures/ids_yuid.json
)

SIZE(LARGE)

TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

END()
