BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(1200)

TEST_SRCS(wl_test_stream.py)

PEERDIR(
    contrib/python/mock
    crypta/lib/python/yql_runner/tests
    crypta/graph/data_import/watch_log/lib
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/bswatch_log.json          /fixtures/bswatch_log.json
    fixtures/radius.json               /fixtures/radius.json
    fixtures/devid.json                /fixtures/devid.json
    fixtures/test_key                  /fixtures/test_key
    fixtures/approved_domens.json      /fixtures/approved_domens.json
)

DATA(
    # sandbox resource GEODATA5BIN_STABLE
    # sbr://491696398  # geodata5.bin
    sbr://669391278  # geodata6.bin; 2018-09-09
)

SIZE(LARGE)

TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

END()
