BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(500)

TEST_SRCS(yuid_info_month_test.py)

PEERDIR(
    # devtools/swag/lib
    # yql/library/python
    contrib/python/mock
    crypta/lib/python/yql_runner/tests
    crypta/graph/data_import/yuid_info_month/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/yuid_with_info_day.json                /fixtures/yuid_with_info_day.json
    fixtures/yuid_with_info_day_spec.json           /fixtures/yuid_with_info_day_spec.json
    fixtures/yuid_with_info_day_schema.json         /fixtures/yuid_with_info_day_schema.json
    fixtures/profiles_for_14days.json               /fixtures/profiles_for_14days.json
    fixtures/profiles_for_14days_schema.json        /fixtures/profiles_for_14days_schema.json
)

DATA(
    # sandbox resource GEODATA5BIN_STABLE
    # sbr://491696398  # geodata5.bin
    sbr://669391278  # geodata6.bin; 2018-09-09
)

SIZE(MEDIUM)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)
INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

REQUIREMENTS(ram:9)

END()
