BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(600)

TEST_SRCS(test.py)

PEERDIR(
    contrib/python/mock
    crypta/lib/python/yql_runner/tests
    crypta/graph/households/data_import/increment_day/lib
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/watch1.json     /fixtures/tbl1.json
    fixtures/watch2.json     /fixtures/tbl2.json
    fixtures/processed.json /fixtures/processed.json
    fixtures/17.json        /fixtures/17.json
    fixtures/18.json        /fixtures/18.json
    fixtures/dates.json     /fixtures/dates.json
)

SIZE(MEDIUM)

NO_CHECK_IMPORTS()

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

END()
