BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(600)

TEST_SRCS(test.py)

PEERDIR(
    contrib/python/mock
    crypta/lib/python/yql_runner/tests
    crypta/graph/households/data_import/watchlog/lib
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/watch0.json    /fixtures/watch0.json
    fixtures/watch1.json    /fixtures/watch1.json
    fixtures/watch2.json    /fixtures/watch2.json
    fixtures/processed.json /fixtures/processed.json
)

# SIZE(LARGE)
SIZE(MEDIUM)

# TAG(
#     ya:fat
#     ya:noretries
# )

NO_CHECK_IMPORTS()

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

END()
