BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(600)

TEST_SRCS(test.py)

PEERDIR(
    contrib/python/mock
    yt/python/client
    crypta/lib/python/yql_runner/tests
    crypta/graph/households/hh_composition/lib
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/homework_yuid.json /fixtures/homework_yuid.json
    fixtures/yuid_with_all.json /fixtures/yuid_with_all.json
    fixtures/profiles.json      /fixtures/profiles.json
    fixtures/hh_reversed.json   /fixtures/hh_reversed.json
    fixtures/hh_to_bb.json      /fixtures/hh_to_bb.json
    fixtures/composition.json   /fixtures/composition.json
)

SIZE(MEDIUM)

NO_CHECK_IMPORTS()

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

DEPENDS(
    # embedded yql bins
    yql/tools/mrjob
    yql/tools/udf_resolver
    # udfs
    ydb/library/yql/udfs/common/digest
    yql/udfs/common/python/python_arc
    ydb/library/yql/udfs/common/re2
    ydb/library/yql/udfs/common/string
    yql/udfs/common/unicode
    ydb/library/yql/udfs/common/yson2
    yql/udfs/crypta/soup
)

END()
