BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(600)

TEST_SRCS(test.py)

PEERDIR(
    contrib/python/mock
    crypta/lib/python/yql_runner/tests
    crypta/graph/households/hh_match/lib
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    # test prepare
    fixtures/hw.json        /fixtures/hw.json
    fixtures/matching.json  /fixtures/matching.json
    fixtures/ip_dt_08.json  /fixtures/ip_dt_08.json
    fixtures/ip_dt_09.json  /fixtures/ip_dt_09.json
    fixtures/ip_dt_10.json  /fixtures/ip_dt_10.json

    # test mrcc
    fixtures/ccid_ccid.json      /fixtures/ccid_ccid.json

    # test finish
    fixtures/crypta_id_crypta_id.json   /fixtures/crypta_id_crypta_id.json
    fixtures/crypta_id_yuid.json        /fixtures/crypta_id_yuid.json
    fixtures/homeless_tvs.json          /fixtures/homeless_tvs.json
    fixtures/all_yuids.json             /fixtures/all_yuids.json
)

SIZE(MEDIUM)

NO_CHECK_IMPORTS()

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

REQUIREMENTS(ram:10)

END()
