package ru.yandex.crypta.graph2.dao.yt.local.fastyt.client;

import java.time.Duration;
import java.util.Collection;
import java.util.Map;
import java.util.Optional;

import ru.yandex.inside.yt.kosher.common.GUID;
import ru.yandex.inside.yt.kosher.operations.Operation;
import ru.yandex.inside.yt.kosher.operations.OperationProgress;
import ru.yandex.inside.yt.kosher.operations.OperationStatus;
import ru.yandex.inside.yt.kosher.operations.YtOperations;
import ru.yandex.inside.yt.kosher.operations.specs.EraseSpec;
import ru.yandex.inside.yt.kosher.operations.specs.JoinReduceSpec;
import ru.yandex.inside.yt.kosher.operations.specs.MapReduceSpec;
import ru.yandex.inside.yt.kosher.operations.specs.MapSpec;
import ru.yandex.inside.yt.kosher.operations.specs.MergeSpec;
import ru.yandex.inside.yt.kosher.operations.specs.ReduceSpec;
import ru.yandex.inside.yt.kosher.operations.specs.RemoteCopySpec;
import ru.yandex.inside.yt.kosher.operations.specs.SortSpec;
import ru.yandex.inside.yt.kosher.operations.specs.VanillaSpec;
import ru.yandex.inside.yt.kosher.ytree.YTreeNode;
import ru.yandex.yt.ytclient.proxy.request.ResumeOperation;
import ru.yandex.yt.ytclient.proxy.request.SuspendOperation;
import ru.yandex.yt.ytclient.proxy.request.UpdateOperationParameters;

import static ru.yandex.inside.yt.kosher.operations.OperationStatus.COMPLETED;

public class YtOperationsFakeImpl implements YtOperations {
    @Override
    public OperationStatus status(GUID operationId) {
        return null;
    }

    @Override
    public OperationProgress progress(GUID operationId) {
        return null;
    }

    @Override
    public YTreeNode result(GUID operationId) {
        return null;
    }

    @Override
    public GUID merge(Optional<GUID> transactionId, boolean pingAncestorTransactions, MergeSpec spec) {
        return null;
    }

    @Override
    public GUID erase(Optional<GUID> transactionId, boolean pingAncestorTransactions, EraseSpec spec) {
        return null;
    }

    @Override
    public GUID map(Optional<GUID> transactionId, boolean pingAncestorTransactions, MapSpec spec) {
        return null;
    }

    @Override
    public GUID reduce(Optional<GUID> transactionId, boolean pingAncestorTransactions, ReduceSpec spec) {
        return null;
    }

    @Override
    public GUID joinReduce(Optional<GUID> transactionId, boolean pingAncestorTransactions, JoinReduceSpec spec) {
        return null;
    }

    @Override
    public GUID sort(Optional<GUID> transactionId, boolean pingAncestorTransactions, SortSpec spec) {
        return null;
    }

    @Override
    public GUID mapReduce(Optional<GUID> transactionId, boolean pingAncestorTransactions, MapReduceSpec spec) {
        return null;
    }

    @Override
    public GUID remoteCopy(RemoteCopySpec spec) {
        return null;
    }

    @Override
    public void abort(GUID operationId) {

    }

    @Override
    public Operation getOperation(GUID operationId) {
        return null;
    }

    @Override
    public Map<String, YTreeNode> getOperationInfo(GUID operationId, Duration timeout, Collection<String> attributes) {
        return null;
    }

    @Override
    public GUID vanilla(Optional<GUID> transactionId, boolean pingAncestorTransactions, VanillaSpec spec) {
        return null;
    }

    @Override
    public Map<String, YTreeNode> listJobs(GUID operationId, Map<String, YTreeNode> attributes) {
        return null;
    }

    @Override
    public String getJobStderr(GUID operationId, GUID jobId) {
        return null;
    }

    @Override
    public void updateOperationParameters(UpdateOperationParameters operationParameters) {

    }

    @Override
    public void suspendOperation(SuspendOperation req) {

    }

    @Override
    public void resumeOperation(ResumeOperation req) {

    }


    public static class OperationStub implements Operation {

        private GUID id = GUID.create();

        @Override
        public GUID getId() {
            return id;
        }

        @Override
        public OperationStatus getStatus() {
            return COMPLETED;
        }

        @Override
        public YTreeNode getResult() {
            return null;
        }

        @Override
        public void await() {

        }

        @Override
        public void await(Duration timeout) {

        }

        @Override
        public void abort() {

        }
    }
}
