package ru.yandex.crypta.graph2.dao.yt.local.fastyt.fs;

import java.io.InputStream;
import java.io.OutputStream;

import ru.yandex.bolts.collection.Option;
import ru.yandex.inside.yt.kosher.cypress.YPath;
import ru.yandex.inside.yt.kosher.ytree.YTreeMapNode;

public interface LocalYtDataLayer<NodeType> {

    InputStream createInputStream(YPath path);

    OutputStream createOutputStream(YPath path);

    void setMetadata(YPath path, YTreeMapNode metadata);

    Option<YTreeMapNode> getMetadata(YPath path);

    /**
     * Represents the key that is used to store current YPath data
     */
    NodeType convertToLocalNode(YPath ypath);
}
