package ru.yandex.crypta.graph2.model.matching.merge.algo.score;

import java.util.Set;

import ru.yandex.bolts.collection.CollectionF;
import ru.yandex.bolts.collection.ListF;
import ru.yandex.crypta.graph2.model.matching.component.Component;
import ru.yandex.crypta.graph2.model.matching.component.GraphInfo;
import ru.yandex.crypta.graph2.model.matching.score.MetricsTree;
import ru.yandex.crypta.graph2.model.soup.edge.Edge;
import ru.yandex.crypta.graph2.model.soup.vertex.Vertex;
import ru.yandex.inside.yt.kosher.impl.operations.utils.YtSerializable;

/**
 * Estimates strength of link between components
 */
public interface LinkScoringStrategy extends YtSerializable {

    /**
     * TODO: why several components? Maybe two is enough
     */
    MetricsTree getScore(CollectionF<Component> components, ListF<Edge> betweenEdges, GraphInfo graphInfo);

    boolean isCutInteresting(ListF<Set<Vertex>> connectedSets);
}
