
USE hahn;

$date = '{{ date }}';
$daily_stats = '//home/crypta/production/state/fingerprint/ssp/stats/' || '{{ date }}' ;

$ssp_metrics =
    SELECT
        $date AS fielddate,
        "sspid_" || sspid AS source,
        "ssp" AS key,
        "pairs" AS cnt_type,
        "all" AS with_idfa,
        "daily" AS span,

        0 AS total,
        0. AS data_rate,
        0. AS total_recall,

        pairs_with_idfa_cnt AS fp,
        idfa_pairs_cnt AS real,
        pairs_true_idfa_cnt AS true_idfa,
        IF(Math::IsFinite(precision), precision, 0.) AS precision,
        IF(Math::IsFinite(recall), recall, 0.) AS recall,
        0 AS total_precision,
        0 AS coverage,
        0. AS total_coverage,

        0 AS with_cid,
        0 AS true_cid,
        0. AS cid_rate,
    FROM $daily_stats
;
