PY2_LIBRARY()

OWNER(g:crypta-idfy)

PY_SRCS(__init__.py)

PEERDIR(
    yt/python/client
    contrib/python/Jinja2
    crypta/lib/python/jinja_resource
    crypta/lib/python/solomon
    contrib/python/pandas
    contrib/python/numpy
    contrib/python/fbprophet
    # contrib/python/matplotlib
    # contrib/python/seaborn
    # contrib/python/pandas
    library/cpp/resource
    library/python/resource
    ads/bsyeti/exp_stats/py_lib
    crypta/graph/metrics/lib
    crypta/graph/metrics/helpers
)

RESOURCE(
    configs/metrics.yaml            /configs/metrics.yaml
    configs/storage.yaml            /configs/storage.yaml
)

RESOURCE(
    yql/common.sql                  /templates/yql/common.sql.j2
    yql/experiment.sql              /templates/yql/experiment.sql.j2
    yql/single.sql                  /templates/yql/single.sql.j2
    yql/separate.sql                /templates/yql/separate.sql.j2
    yql/partial.sql                 /templates/yql/partial.sql.j2

    yql/adaptors/matching_v1.sql           /templates/yql/adaptors/matching_v1.sql.j2
    yql/adaptors/matching_v2.sql           /templates/yql/adaptors/matching_v2.sql.j2
    yql/adaptors/matching_v2.sql           /templates/yql/adaptors/matching_v2exp.sql.j2
    yql/adaptors/matching_v2_export.sql    /templates/yql/adaptors/matching_v2_export.sql.j2
    yql/adaptors/matching_michurin.sql     /templates/yql/adaptors/matching_michurin.sql.j2

    yql/ads/chevent.sql                 /templates/yql/ads/chevent.sql.j2
    yql/ads/chevent_awareness.sql       /templates/yql/ads/chevent_awareness.sql.j2
    yql/ads/coverage.sql                /templates/yql/ads/coverage.sql.j2
    yql/ads/detailed.sql                /templates/yql/ads/detailed.sql.j2
    yql/ads/duplicated_crypta_ids.sql   /templates/yql/ads/duplicated_crypta_ids.sql.j2
    yql/ads/experiment.sql              /templates/yql/ads/experiment.sql.j2

    yql/antispam/antispam.sql       /templates/yql/antispam/antispam.sql.j2

    yql/avito/query.sql             /templates/yql/avito/query.sql.j2

    yql/browsers/desktop.sql        /templates/yql/browsers/desktop.sql.j2

    yql/device_id_in_crypta_id/query.sql                   /templates/yql/device_id_in_crypta_id/query.sql.j2
    yql/device_id_in_crypta_id/select_for_dashboard.sql    /templates/yql/device_id_in_crypta_id/select_for_dashboard.sql.j2
    yql/device_id_in_crypta_id/vertices_v1.sql         /templates/yql/device_id_in_crypta_id/vertices_v1.sql.j2
    yql/device_id_in_crypta_id/vertices_v2.sql         /templates/yql/device_id_in_crypta_id/vertices_v2.sql.j2
    yql/device_id_in_crypta_id/vertices_v2.sql         /templates/yql/device_id_in_crypta_id/vertices_v2exp.sql.j2

    yql/devices/devices.sql                                     /templates/yql/devices/devices.sql.j2
    yql/app_device_id_coverage/app_device_id_coverage.sql         /templates/yql/app_device_id_coverage/app_device_id_coverage.sql.j2

    yql/entropy/entropy.sql         /templates/yql/entropy/entropy.sql.j2

    yql/plus/family.sql             /templates/yql/plus/family.sql.j2
    yql/plus/subscriptions.sql      /templates/yql/plus/subscriptions.sql.j2

    yql/humans/humans.sql           /templates/yql/humans/humans.sql.j2
    yql/id_types/query.sql          /templates/yql/id_types/query.sql.j2
    yql/radius/radius.sql           /templates/yql/radius/radius.sql.j2

    yql/retargeting/main.sql        /templates/yql/retargeting/main.sql.j2
    yql/retargeting/apply_offline.sql /templates/yql/retargeting/apply_offline.sql.j2
    yql/retargeting/parse_hit.sql   /templates/yql/retargeting/parse_hit.sql.j2
    yql/retargeting/crypta_export.sql /templates/yql/retargeting/crypta_export.sql.j2
    yql/retargeting/crypta_matching.sql /templates/yql/retargeting/crypta_matching.sql.j2
    yql/retargeting/count_metrics.sql /templates/yql/retargeting/count_metrics.sql.j2

    yql/stable/cryptaids.sql        /templates/yql/stable/cryptaids.sql.j2
    yql/stable/make_diff.sql        /templates/yql/stable/make_diff.sql.j2

    yql/staff/staff.sql             /templates/yql/staff/staff.sql.j2
    yql/taxi/taxi.sql               /templates/yql/taxi/taxi.sql.j2
    yql/similarity/similarity.sql   /templates/yql/similarity/similarity.sql.j2

    yql/yuids/yuids.sql             /templates/yql/yuids/yuids.sql.j2
    yql/ads/avg_profile_size.sql    /templates/yql/ads/avg_profile_size.sql.j2
    yql/ads/overlimit_percent.sql    /templates/yql/ads/overlimit_percent.sql.j2
    yql/ads/qualifiers_identification.sql    /templates/yql/ads/qualifiers_identification.sql.j2
)

END()
