BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(3000)

TEST_SRCS(test_stats.py)

PEERDIR(
    contrib/python/mock
    crypta/lib/python/yql_runner/tests
    crypta/graph/metrics/stats_base/lib
    devtools/swag/lib
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/antispam.attrs.json            /antispam.attrs.json
    fixtures/antispam.json                  /antispam.json
    fixtures/beh_profile_hit_log.attrs.json /beh_profile_hit_log.attrs.json
    fixtures/beh_profile_hit_log.json       /beh_profile_hit_log.json
    fixtures/cross_dev.attrs.json           /cross_dev.attrs.json
    fixtures/cross_dev.json                 /cross_dev.json
    fixtures/dev_info_day.attrs.json        /dev_info_day.attrs.json
    fixtures/dev_info_day.json              /dev_info_day.json
    fixtures/device_id_info_month.attrs.json  /device_id_info_month.attrs.json
    fixtures/device_id_info_month.json        /device_id_info_month.json
    fixtures/uuid_info_month.attrs.json     /uuid_info_month.attrs.json
    fixtures/uuid_info_month.json           /uuid_info_month.json
    fixtures/edges_cid.attrs.json           /edges_cid.attrs.json
    fixtures/edges_cid.json                 /edges_cid.json
    fixtures/indevice.attrs.json            /indevice.attrs.json
    fixtures/indevice.json                  /indevice.json
    fixtures/logs_chevent.attrs.json        /logs_chevent.attrs.json
    fixtures/logs_chevent.json              /logs_chevent.json
    fixtures/logs_proto_event.attrs.json    /logs_proto_event.attrs.json
    fixtures/logs_proto_event.json          /logs_proto_event.json
    fixtures/plus_data.attrs.json           /plus_data.attrs.json
    fixtures/plus_data.json                 /plus_data.json
    fixtures/shared.attrs.json              /shared.attrs.json
    fixtures/shared.json                    /shared.json

    fixtures/soup/soup_edges.attrs.json                                  /soup/soup_edges.attrs.json
    fixtures/soup/soup_edges.json                                        /soup/soup_edges.json
    fixtures/soup/gaid_mm_device_id_app-metrica_mm.attrs.json            /soup/gaid_mm_device_id_app-metrica_mm.attrs.json
    fixtures/soup/gaid_mm_device_id_app-metrica_mm.json                  /soup/gaid_mm_device_id_app-metrica_mm.json
    fixtures/soup/idfa_mm_device_id_app-metrica_mm.attrs.json            /soup/idfa_mm_device_id_app-metrica_mm.attrs.json
    fixtures/soup/idfa_mm_device_id_app-metrica_mm.json                  /soup/idfa_mm_device_id_app-metrica_mm.json
    fixtures/soup/mm_device_id_uuid_app-metrica_mm.attrs.json            /soup/mm_device_id_uuid_app-metrica_mm.attrs.json
    fixtures/soup/mm_device_id_uuid_app-metrica_mm.json                  /soup/mm_device_id_uuid_app-metrica_mm.json

    fixtures/staff.attrs.json               /staff.attrs.json
    fixtures/staff.json                     /staff.json
    fixtures/taxi.attrs.json                /taxi.attrs.json
    fixtures/taxi.json                      /taxi.json
    fixtures/v1_data.attrs.json             /v1_data.attrs.json
    fixtures/v1_data.json                   /v1_data.json
    fixtures/v2_data.attrs.json             /v2_data.attrs.json
    fixtures/v2_data.json                   /v2_data.json
    fixtures/vertices_properties_cid.attrs.json  /vertices_properties_cid.attrs.json
    fixtures/vertices_properties_cid.json        /vertices_properties_cid.json
    fixtures/watch_log.attrs.json           /watch_log.attrs.json
    fixtures/watch_log.json                 /watch_log.json
    fixtures/yuid_rlogin.attrs.json         /yuid_rlogin.attrs.json
    fixtures/yuid_rlogin.json               /yuid_rlogin.json
    fixtures/yuid_with_all_info.attrs.json  /yuid_with_all_info.attrs.json
    fixtures/yuid_with_all_info.json        /yuid_with_all_info.json
    fixtures/avg_profile_size.attrs.json    /avg_profile_size.attrs.json
    fixtures/avg_profile_size.json          /avg_profile_size.json
    fixtures/overlimit_percent.attrs.json   /overlimit_percent.attrs.json
    fixtures/overlimit_percent.json         /overlimit_percent.json
)

DATA(
    sbr://1615548433  # bsyeti-configs BS_YETI_LIGHT_CONFIGS
    # sbr://1614173763  # configs EXPERIMENTS_CONFIG
    sbr://1627813402  # ab_cfg BIGB_AB_EXPERIMENTS_PRODUCTION_CONFIG
)

SIZE(LARGE)

TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)
INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)
INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yql.inc)

NO_CHECK_IMPORTS()

END()
