def wrap_path(field):
    return field if isinstance(field, list) else [field]


def get_value(record, path):
    value = record
    subpath = []
    for field in path:
        if not isinstance(value, dict):
            return False, subpath

        subpath.append(field)

        if field not in value:
            return False, subpath
        value = value[field]

    return True, value
