from crypta.prism.lib.config import fields

from ads.bsyeti.libs.primitives.counter_proto import counter_ids_pb2
from yabs.server.proto.keywords import keywords_data_pb2


COUNTERS_TO_FEATURES = {counter_ids_pb2.ECounterId.CI_QUERY_CATEGORIES_INTEREST: fields.BINDINGS}
KEYWORDS_TO_FEATURES = {
    keywords_data_pb2.EKeyword.KW_DEVICE_MODEL_BT: fields.MOBILE_MODELS,
    keywords_data_pb2.EKeyword.KW_DETAILED_DEVICE_TYPE_BT: fields.OPERATING_SYSTEMS,
    keywords_data_pb2.EKeyword.KW_USER_REGION: fields.REGIONS,
}

SEGMENTS = [fields.P1, fields.P2, fields.P3, fields.P4, fields.P5]
PRISM_SEGMENT_TARGET_MAPPING = {
    fields.UNKNOWN: -1,
    fields.P1: 0,
    fields.P2: 1,
    fields.P3: 2,
    fields.P4: 3,
    fields.P5: 4,
}
PRISM_SEGMENT_CLUSTER_RANGE = {
    fields.UNKNOWN: set(range(0, 1)),
    fields.P1: set(range(1, 8)),
    fields.P2: set(range(8, 52)),
    fields.P3: set(range(52, 92)),
    fields.P4: set(range(93, 100)),
    fields.P5: set(range(100, 101)),
}
