from crypta.profile.runners.vectors_update.lib import utils
from crypta.profile.runners.vectors_update.lib.utils import fields
from crypta.profile.utils.config import config
from crypta.siberia.bin.custom_audience.sites_clustering.lib.utils import (
    config as clustering_config,
    fields as clustering_fields,
)


def update(yt_client, yql_client):
    with yt_client.Transaction() as transaction:
        utils.update_vectors(
            yt_client=yt_client,
            transaction=transaction,
            yql_client=yql_client,
            segment2vec_table=config.SITE2VEC_VECTORS_TABLE,
            clustering_config=clustering_config,
            clustering_fields=clustering_fields,
            segment2vec_fields=fields.site2vec_fields,
            id_types=None,
        )
