#include "list_segment_users_request_parser.h"

#include <crypta/lib/native/cgiparam/cgiparam.h>
#include <crypta/siberia/bin/core/lib/logic/common/helpers/cgiparam.h>

#include <library/cpp/http/misc/parsed_request.h>
#include <util/string/cast.h>

using namespace NCrypta;
using namespace NCrypta::NSiberia;

TListSegmentUsersRequest TListSegmentUsersRequestParser::Parse(const TString& query, const TStringBuf& body) {
    TParsedHttpLocation httpLocation(query);

    Y_ENSURE(httpLocation.Path == "/segments/list_users", "Not /segments/list_users request");

    return Parse(TCgiParameters(httpLocation.Cgi), body);
}

TListSegmentUsersRequest TListSegmentUsersRequestParser::Parse(const TCgiParameters& cgi, const TStringBuf& body) {
    Y_UNUSED(body);

    return {
        .UserSetId = NCgiParamUtils::GetUserSetId(cgi),
        .SegmentId = NCgiParamUtils::GetSegmentId(cgi),
        .LastUserId = NCgiParam::GetOptional<TUserId>(cgi, "last_user_id").GetOrElse(0),
        .Limit = NCgiParamUtils::GetLimit(cgi).GetOrElse(100),
    };
}
