#pragma once

#include <crypta/siberia/bin/core/lib/logic/common/request_processor/request_processor.h>
#include <crypta/siberia/bin/core/lib/logic/ping/request/ping_request_parser.h>

#include <library/cpp/tvmauth/client/facade.h>

namespace NCrypta::NSiberia {
    class TPingProcessor : public TRequestProcessor<TPingRequest, TPingRequestParser> {
        using TBase = TRequestProcessor<TPingRequest, TPingRequestParser>;

    public:
        TPingProcessor(const NTvmAuth::TTvmClient& tvmClient, const TStats::TSettings& statsSettings);

    private:
        void Process(NHttp::TRequestReply& reply, const TPingRequest& request) override final;

        const NTvmAuth::TTvmClient& TvmClient;
    };
}
