#pragma once

#include <crypta/siberia/bin/custom_audience/ca_builder/proto/ca_binding.pb.h>

#include <mapreduce/yt/interface/client.h>

namespace NCrypta::NSiberia::NCustomAudience::NCaBuilder {
    class TDecreaseSizeReducer: public NYT::IReducer<NYT::TTableReader<TCaBinding>, NYT::TTableWriter<TCaBinding>> {
    public:
        TDecreaseSizeReducer() = default;
        explicit TDecreaseSizeReducer(size_t filterThreshold);

        void Do(TReader* reader, TWriter* writer) override;
        Y_SAVELOAD_JOB(Threshold);

    private:
        size_t Threshold = 0;
    };
}
