#pragma once

#include <crypta/styx/services/api/lib/config/ping_config.pb.h>
#include <crypta/styx/services/api/lib/logic/common/request_processor/request_processor.h>

#include <library/cpp/tvmauth/client/facade.h>

namespace NCrypta::NStyx::NApi {
    class TPingProcessor : public TRequestProcessor {
    public:
        explicit TPingProcessor(
                const TPingConfig& pingConfig,
                const NTvmAuth::TTvmClient& tvmClient,
                const TStats::TSettings& statsSettings);
        ~TPingProcessor() override = default;

    private:
        void DoProcess(NHttp::TRequestReply& reply, const TClient& clientInfo) override;

        const TString PingId;
        const NTvmAuth::TTvmClient& TvmClient;
    };
}
