from crypta.tx.proto.transaction_source_pb2 import ETransactionSource
from crypta.tx.services.data_import.lib import common_task


def add_args_subparser(subparsers):
    parser = subparsers.add_parser("market", help="Import Market data")
    parser.set_defaults(function=run)


def run(config, logger):
    common_task.run(
        config=config,
        transaction_source=ETransactionSource.MARKET,
        yql_query="/query/market_import.yql",
        yql_query_params={
            "market_dir": config.MarketDir,
        },
        logger=logger,
    )
