BUILD_ONLY_IF(OS_LINUX AND CLANG AND NOT SANITIZER_TYPE AND NOT WITH_VALGRIND)

OWNER(g:crypta-idfy)

PY2TEST()

TIMEOUT(1200)

TEST_SRCS(fuzzy2_test.py)

PEERDIR(
    contrib/python/mock
    crypta/graph/data_import/fuzzy2/lib
    crypta/lib/python/yql_runner/tests
    devtools/swag/lib
    library/python/resource
    library/cpp/resource
    mapreduce/yt/python/lite
    yql/library/embedded/python
    yql/library/python
    yql/library/test_framework
    ydb/library/yql/providers/common/proto
)

RESOURCE(
    fixtures/bswatch_log.json           /fixtures/bswatch_log.json
    fixtures/fuzzy2_metrica.json        /fixtures/fuzzy2_metrica.json
    fixtures/fuzzy2_metrica.spec.json   /fixtures/fuzzy2_metrica.spec.json
    fixtures/yuid_with_all.json         /fixtures/yuid_with_all.json
    fixtures/yuid_with_all.spec.json    /fixtures/yuid_with_all.spec.json
    fixtures/dev_yuids.json             /fixtures/dev_yuid_fuzzy2.json
    fixtures/ua_profiles_devid.json     /fixtures/ua_profiles_devid.json
    fixtures/ua_profiles_yuid.json      /fixtures/ua_profiles_yuid.json
)

DATA(
    # sandbox resource GEODATA5BIN_STABLE
    # sbr://491696398  # geodata5.bin
    sbr://669391278  # geodata6.bin; 2018-09-09
)

SIZE(LARGE)

TAG(
    ya:fat
    ya:noretries
)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/local_yt.inc)

INCLUDE(${ARCADIA_ROOT}/crypta/lib/inc/embedded_yql.inc)

NO_CHECK_IMPORTS()

END()
