from crypta.graph.fuzzy.lib.luiger import BaseTask, DateParameter
import components_size_metrics
import score_metrics
import export_size_metrics

requires_tasks = [
    components_size_metrics.FuzzyComponentsSize,
    score_metrics.ScoreMetrics,
    export_size_metrics.ExportSize,
]


class CalculateAllMetrics(BaseTask):

    date = DateParameter()

    def requires(self):
        for task in requires_tasks:
            yield task(date=self.date)

    def _run(self):
        pass
